#include "queue.h"
#include "stockex.h"
#include "good.h"
#include "auxiliaire.h"
#include "global.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#include <math.h>


//Permet de doner des noms aux ours
static  char* nom[]={"Teddy Smart","Freddy", "Napoléon","Frère des ours","Petit ours brun","Maman ours brun","Papa ours brun","Boule de Neige","Teddy 8","Teddy 9","Teddy 10","Teddy 11","Teddy 12","Teddy 13","Teddy 14","Teddy 15","Teddy 16","Teddy 17","Teddy 18","Teddy 19"};

//Utilisé pour l'initialisation des teddy
struct teddy* created_teddy;


//Permet de remplir la queue de manière initiale
struct queue fill_queue(int player_number,const struct stockex* Catane)
{
    created_teddy= malloc(player_number*(sizeof(struct teddy)+8));
    struct queue queue_game=queue__new();
    for(int i=0; i<player_number; i=i+1){
      created_teddy[i].name=nom[i]; //initialisation nom
      struct wallet teddy_wallet={{1000,0,0}}; //Portefeuille initial
      created_teddy[i].initialisation=teddy_wallet;
      created_teddy[i].place= Catane; //Première place
      created_teddy[i].place_visited[0]= Catane; //Mise à jour de l'ensemble des places visitées
      created_teddy[i].nbr_place_visited=1; //Et de son compteur
      if(i==0){
        created_teddy[i].type=1; //Le premier teddy est malin
      }
      else{
        created_teddy[i].type = 0; //Les autres non
      }
      queue__push(&queue_game,0,&created_teddy[i]); //Mis dans la queue
    }
    return queue_game;
}


//Permet d'actualiser le portefeuille d'un ours + calculer le temps que l'ours passe
struct play do_transac(struct teddy* economiste, int stockex_number)
{
  int time=0;
    struct play active_teddy_play;
    const struct transac *choose_transac=choose_transaction(economiste,stockex_number);//fais correspondre le numéro de transaction avec la transaction
    int max_nbr_transac=maximum_transaction(economiste,choose_transac);
    if (max_nbr_transac==0){ //si le teddy ne peut pas faire de transactions
      time +=1;
      economiste->priority_teddy+=time;
      active_teddy_play.time=time;
      active_teddy_play.transac=economiste->initialisation;
      return active_teddy_play;
    }
    int nbr_times_transac= rand()%max_nbr_transac;
    if(nbr_times_transac==0){ //si le teddy choisit de ne pas faire de transaction , on le force a en faire au moins une
      nbr_times_transac=1;
    }
    for(int i = 0; i<MAX_GOOD; i=i+1){ //actualise le portefeuille
      struct wallet wallet_in = transac__in_wallet(choose_transac);
      struct wallet wallet_out = transac__out_wallet(choose_transac);
      economiste->initialisation.data[i]=economiste->initialisation.data[i]+nbr_times_transac*wallet_out.data[i]-nbr_times_transac*wallet_in.data[i];
    }
    time = 1 + log(nbr_times_transac)/log(2); //actualise le temps et la structure play
    active_teddy_play.time=time;
    active_teddy_play.transac=economiste->initialisation;
    economiste->priority_teddy+=time;
    active_teddy_play.time=time;
    return active_teddy_play;
}

int tab_values[MAX_TRANSACTION];
int tab_times[MAX_TRANSACTION];
int tab_mul[MAX_TRANSACTION];

//Permet de faire une transaction via la méthode Brute Force
struct play do_smart_transac(struct teddy* economiste)
{
  int* tab_mul=calculate_tab_mul(economiste);
  int rang_maximum = rang_max(tab_mul, stockex__num_transactions(economiste->place));
  int time=0;
  struct play active_teddy_play;
  const struct transac* do_transac = stockex__transaction(economiste->place, rang_maximum);
  int max_nbr_transac=tab_times[rang_maximum];
  if (max_nbr_transac==0){ //si le teddy ne peut pas faire de transactions
    time +=1;
    economiste->priority_teddy+=time;
    active_teddy_play.time=time;
    active_teddy_play.transac=economiste->initialisation;
    return active_teddy_play;
  }
  for(int i = 0; i<MAX_GOOD; i=i+1){ //actualise le portefeuille
    struct wallet wallet_in = transac__in_wallet(do_transac);
    struct wallet wallet_out = transac__out_wallet(do_transac);
    economiste->initialisation.data[i]=economiste->initialisation.data[i]+ max_nbr_transac*wallet_out.data[i]- max_nbr_transac*wallet_in.data[i];
  }
  time = 1 + log( max_nbr_transac)/log(2); //actualise le temps et la structure play
  active_teddy_play.time=time;
  active_teddy_play.transac=economiste->initialisation;
  economiste->priority_teddy+=time;
  active_teddy_play.time=time;
  return active_teddy_play;
}

//Permet de choisir le type de transaction qu'un ours va faire
struct play which_transac(struct teddy* economiste, int stockex_number)
{
  if(is_smart(economiste)==1)
    return do_smart_transac(economiste);
  else
    return do_transac(economiste,stockex_number);
}

//Permet d'afficher les résultats
void display_results(struct queue* queue_game, int player_number)
{

  if (player_number<0) {
    printf("[ ERROR ] \033[031m player_number error \033[0m    \t ");
    return;
  }
  if (queue_game->length_queue==0 || queue_game==NULL){
    printf("[ ERROR ] \033[031m queue error \033[0m        \t \t ");
    return;
  }
  int tab_results[player_number];
    struct teddy* tab_teddy[player_number];
    for(int i=0;i<player_number;i=i+1){
      struct teddy* actual_teddy=queue__pop(queue_game);
      tab_results[i]=wallet__value(actual_teddy->initialisation);
      tab_teddy[i]= actual_teddy;
    }
    int max=0;
    int position_max=-1;
    for(int i=0;i<player_number;i=i+1){
      if (max <= tab_results[i]) {
        max = tab_results[i];
        position_max = i;
      }
    }
    struct teddy *teddy_winner = tab_teddy[position_max];
    char *name = teddy_winner->name;
    printf("le gagnant s'appelle %s et à %d honey et il est du type %d \n",
           name, max, teddy_winner->type);

}
//Permet de free les éléments relatifs à la file d'attente
void free_queue()
{
  free(created_teddy);
}
